function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
// 公共点击leaflet点
function markerClickLeaflet(_ref) {
  var points = _ref.points,
    layerGroup = _ref.layerGroup,
    clearMarkers = _ref.clearMarkers,
    defaultIcon = _ref.defaultIcon,
    onClick = _ref.onClick;
  // Must only one layer
  layerGroup.eachLayer(function (layer) {
    layer.on('click', function (e) {
      var _e$target;
      var latitude = e.latlng.lat;
      var longitude = e.latlng.lng;

      // Get click point
      var currentPoint = null;
      var _iterator = _createForOfIteratorHelper(points),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var point = _step.value;
          if (point.longitude === longitude && point.latitude === latitude) {
            // eslint-disable-next-line
            currentPoint = point;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      onClick(_objectSpread(_objectSpread({
        longitude: longitude,
        latitude: latitude
      }, currentPoint || {}), {}, {
        icon: (e === null || e === void 0 || (_e$target = e.target) === null || _e$target === void 0 || (_e$target = _e$target.options) === null || _e$target === void 0 || (_e$target = _e$target.icon) === null || _e$target === void 0 ? void 0 : _e$target.options) || null,
        setIcon: function setIcon(icon, _ref2) {
          var multiple = _ref2.multiple;
          // Single choice
          if (!multiple) {
            clearMarkers();
            var _iterator2 = _createForOfIteratorHelper(points),
              _step2;
            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                var point = _step2.value;
                var newIcon = (point === null || point === void 0 ? void 0 : point.icon) || defaultIcon;
                if (point.latitude === latitude && point.longitude === longitude) {
                  newIcon = icon;
                }
                var marker = window.L.marker([point.latitude, point.longitude], {
                  icon: newIcon
                });
                marker.addTo(layerGroup);
              }

              // Rebind click
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }
            markerClickLeaflet({
              points: points,
              clearMarkers: clearMarkers,
              layerGroup: layerGroup,
              defaultIcon: defaultIcon,
              onClick: onClick
            });
          }
          // Multiple choice
          else {
            e.target.setIcon(icon);
          }
        },
        remove: function remove() {
          return e.target.remove();
        }
      }));
    });
  });
}
export default markerClickLeaflet;